#include<iostream>
using namespace std;

void wypisz(float tablica[], unsigned ilosc);
void i_bubble(float tablica[], unsigned ilosc);

int main()
{
float dane[] = {0, 12.5, 7, 13.33, 25.23, 10, 9.99, 0.25, 0.98, 1.01};

    cout<<"Program posortuje tablice z metoda \"bubble sort\" - udoskonalona"<<endl;
    cout<<"Przed sortowaniem tablica zawiera dane:"<<endl;
    wypisz(dane, 10);
    cout<<endl;
    
    cout<<endl<<"Sortujemy tablice. Tablica zawiera obecnie dane:"<<endl;
    i_bubble(dane, 10);
    wypisz(dane, 10);
    cout<<endl;
}

void wypisz(float tablica[], unsigned ilosc)
{
unsigned indeks;

    for(indeks=0; indeks<ilosc; indeks++) cout<< tablica[indeks] <<" ";
}

void i_bubble(float tablica[], unsigned ilosc)
{
unsigned i, j;

    // Pierwszego przegladu musimy dokonac
    bool kontynuowac = true;

    for(i = 0; (i < ilosc-1) && kontynuowac; i++)
    {
	//zakladamy optymistycznie, ze kolejnego przegladania NIE BEDZIE
	kontynuowac = false;	
    
	// dokonujemy przegladu tablicy
	for(j = ilosc-1; j > i; j--)
	    if( tablica[j] < tablica[j-1] )
	    {
	    float tymczasowy;
		
		// dokonaj zamiany miejscami elementow
		tymczasowy = tablica[j-1];
		tablica[j-1] = tablica[j];
		tablica[j] = tymczasowy;
		
		// Jesli trzeba bylo dokonac choc jednej zamiany, kontynuuj przegladanie
		kontynuowac = true;
	    }
    }
}
